SystemOrganization addCategory: #MemoryMentor!
SystemOrganization addCategory: #'MemoryMentor-Tests'!

TestCase subclass: #MMMemoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 13:03:36.576'!
testInitialization
	| memory |
	memory := MMMemory from: 16rCAFE size: 100.
	self assert: [ memory startAdress == 16rCAFE ].
	self assert: [ memory byteSize == 100 ]! !

!ByteArray methodsFor: '*MemoryMentor' stamp: 'RL 5/3/2013 11:38:58.14'!
intAt: index
	| word |
	<primitive: 165>
	word := self basicAt: index.
	word < 16r3FFFFFFF ifTrue:[^word]. "Avoid LargeInteger computations"
	^word >= 16r80000000	"Negative?!!"
		ifTrue:["word - 16r100000000"
				(word bitInvert32 + 1) negated]
		ifFalse:[word]! !

!ByteArray methodsFor: '*MemoryMentor' stamp: 'RL 5/3/2013 11:44:13.346'!
intAt: index put: anInteger
	| word |
	<primitive: 166>
	anInteger < 0
		ifTrue:[anInteger < -16r80000000 ifTrue: [self error: anInteger asString , ' out of range'].
				"word := 16r100000000 + anInteger"
				word := (anInteger + 1) negated bitInvert32]
		ifFalse:[anInteger > 16r7FFFFFFF ifTrue: [self error: anInteger asString , ' out of range'].
				word := anInteger].
	self  basicAt: index put: word.
	^anInteger! !

Object subclass: #MMMemory
	instanceVariableNames: 'startAdress memory cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 13:01:36.45'!
from: startAdress size: byteSize
	^ self new
		initializeWithStartAdress: startAdress andByteSize: byteSize;
		yourself! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:42:20.88'!
at: adress putByte: byte
	memory byteAt: (self indexForAdress: adress) put: byte! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:46:36.05'!
at: adress putInt: int
	memory intAt: (self indexForAdress: adress) put: int! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:30:32.702'!
byteAt: adress
	 ^ memory at: (self indexForAdress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 13:04:27.336'!
byteSize
	^ memory size! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:22:47.126'!
cellAtAdress: adress
	^ MMMemoryCell at: (adress roundDownTo: 4) in: self! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:24:07.742'!
cellsDo: aBlock
	^ cells do: aBlock! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:30:26.288'!
indexForAdress: adress
	^ adress - startAdress + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:22:06.52'!
initializeWithStartAdress: adress andByteSize: size
	startAdress := adress.
	memory := ByteArray new: size.
	cells := OrderedCollection new.
	1 to: size/4 do: [ :i |
		cells add: (MMMemoryCell at: (startAdress + 4*i) in: self)
	]! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:39:53.016'!
intAt: adress
	 ^ memory intAt: (self indexForAdress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 13:04:18.3'!
startAdress
	^ startAdress! !

Object subclass: #MMMemoryCell
	instanceVariableNames: 'adress memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 12:47:37.946'!
at: adress in: memory
	 ^ self new
		initializeWithAdress: adress andMemory: memory;
		yourself! !

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 12:41:51.122'!
size
	 ^ 4! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:18:52.68'!
adress
	^ adress! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 12:46:31.62'!
initializeWithAdress: anAdress andMemory: aMemory
	adress := anAdress.
	memory := aMemory! !

BorderedMorph subclass: #MMMemoryMorph
	instanceVariableNames: 'memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemoryMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:14:59.09'!
for: memory
	^ self new
		setupMemory: memory;
		yourself! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:37:29.698'!
initialize
	super initialize.
	self color: Color yellow.
	self
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		listCentering: #center
! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:02:34.86'!
memory: aMemory
	memory := aMemory! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:39:18.13'!
setupMemory: aMemory
	memory := aMemory.
	memory cellsDo: [ :cell |
		self addMorph: (BorderedMorph new extent: 140@18; color: Color green; yourself)
	]! !
